//Software base para OPS010
//Controlador ESP32
//Mapeamento dos IOs e definição das Seriais
// Definição dos pinos do controlador
//Saidas digiais
#define pin_Y1 13
#define pin_Y2 12
#define pin_Y3 27
#define pin_Y4 26
#define pin_Y5 25
#define pin_Y6 33
#define pin_Y7 32
#define pin_Y8 4

//Entradas digitais
#define pin_X1 15
#define pin_X2 14
#define pin_X3 5
#define pin_X4 18
#define pin_X5 19
#define pin_X6 36
#define pin_X7 39
#define pin_X8 34

//Entradas analógicas
#define pin_AI1 35

//Saídas analógicas
#define pin_AO1 23

//Pinos auxiliares
#define ENTX_pin 2 //Pino de comunicação RS485

//Variáveis de controle para o teste
int control = 0;
int estado = 0;
int saida = 0;
unsigned long analog_tmr = 0;
long analog_raw = 0;
float analog = 0;
unsigned long TMR_Loop = 0;
String inputString485 = "";         // a String to hold incoming data
bool stringComplete485 = false;  // whether the string is complete
String inputStringTTL = "";         // a String to hold incoming data
bool stringCompleteTTL = false;  // whether the string is complete

#include "Digitais.h"
#include "Analogicas.h"
#include "Serial485.h"
#include "SerialTTL.h"

void setup() {
  //Inicializa comunicações
  Serial.begin(115200); // (USB)
  Serial1.begin(115200); // (TTL)
  Serial2.begin(115200); //(485)

  //Inicializa hardware
  pinMode(pin_X1, INPUT);
  pinMode(pin_X2, INPUT);
  pinMode(pin_X3, INPUT);
  pinMode(pin_X4, INPUT);
  pinMode(pin_X5, INPUT);
  pinMode(pin_X6, INPUT);
  pinMode(pin_X7, INPUT);
  pinMode(pin_X8, INPUT);

  pinMode(pin_Y1, OUTPUT);
  pinMode(pin_Y2, OUTPUT);
  pinMode(pin_Y3, OUTPUT);
  pinMode(pin_Y4, OUTPUT);
  pinMode(pin_Y5, OUTPUT);
  pinMode(pin_Y6, OUTPUT);
  pinMode(pin_Y7, OUTPUT);
  pinMode(pin_Y8, OUTPUT);
  pinMode(ENTX_pin, OUTPUT);

  digitalWrite(pin_Y1, LOW);
  digitalWrite(pin_Y2, LOW);
  digitalWrite(pin_Y3, LOW);
  digitalWrite(pin_Y4, LOW);
  digitalWrite(pin_Y5, LOW);
  digitalWrite(pin_Y6, LOW);
  digitalWrite(pin_Y7, LOW);
  digitalWrite(pin_Y8, LOW);

  // Configuração da saída analógica
  //(Canal, Frequência, Resolução)
  ledcSetup(0, 1000, 12);
  //(Pino, Canal)
  ledcAttachPin(pin_AO1, 0);

  //Configura variável da comunicação
  inputString485.reserve(200);
  inputStringTTL.reserve(200);

}

void loop() {
  if (millis() > (TMR_Loop + 200)){
    digitais();
    analogicas();
    TMR_Loop = millis();
  }
  Serial485();
  SerialTTL();
}
